#!/usr/bin/perl
# Copyright (c) vhffs project and its contributors
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# 1. Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
#2. Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
#3. Neither the name of vhffs nor the names of its contributors 
#   may be used to endorse or promote products derived from this 
#   software without specific prior written permission.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
#"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
#LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
#FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
#COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
#INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
#BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
#LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
#CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.



package Vhffs::Listengine::Mail;

#Vhffs::User written by sod` <dieu AT gunnm DOT org>

#blablabla, yeah yeah yeah
#how to you feel today ? fucking weather today !

use strict;

sub new
{
	my $class;
	my $this;

	$class = shift;
	
	$this = {};

	bless( $this , $class );

}


sub read_from_stdin
{
	my $self = shift;
	$self->read_from_file( "stdin" );
}

sub read_from_file
{
	my $self		=	shift;
	my $file		=	shift;
	my $line;

	#$what = 0 : has not yet read header 
	#$what = 1 : is reading the header
	#$what = 2 : is reading body
	my $what;
	my $key;
	my $value;

	$what		=	0;

	if( $file	== "stdin" )
	{
		open( FILE , "-");
	}
	else
	{
		open( FILE , "$file" );
	}

	while( $line = <FILE> )
	{
		if( $what == 0 )
		{
			if( $line =~ /^[a-zA-Z0-9\-]+:\s.+$/ )
			{
				#We discover a header line, so we read it now
				$what = 1;
			}
		}
		elsif( $what == 1 )
		{
			if(  $line =~ /^\n$/ )
			{
				$what = 2;
			}
			else
			{
				if( $line =~ /^([a-zA-Z0-9\-]+):\s(.+)$/ )
				{
					( $key , $value ) = ( $line =~ /^([a-zA-Z0-9\-]+):\s(.+)$/ );
					$self->{header}->{$key} = $value;
				}
				else
				{
					$self->{header}->{$key} .= $line;
				}
			}
		}
		else
		{
			$self->{'body'} .=  $line;
		}

	}
}

sub send
{
	my	$self;
	my	$server;
	my	$port;
	my	$proto;
	my	$iaddr;
	my	$port;
	my	$sin;
	my	$err;
	my	$to;
	my	$domain;
	my	$from;


	$self	=	shift;
	$server	=	shift;
	$to		=	shift;
	$from	=	shift;
	$domain	=	shift;

	$err	=	'';

	$proto = getprotobyname('tcp' );
	socket(SOCK, AF_INET, SOCK_STREAM, $proto);
	$iaddr = gethostbyname( $server );
	$port = getservbyname('smtp' , 'tcp' );
	$sin = sockaddr_in( $port , $iaddr );
	connect( SOCK, $sin );
	$err = '';

    recv SOCK, $err, 512, 0;
    send SOCK, "HELO $domain\r\n", 0;
    recv SOCK, $err, 512, 0;
    send SOCK, "MAIL FROM: $from\r\n", 0;
    recv SOCK, $err, 512, 0;

	if( ref( $to ) == 'ARRAY' )
	{
    	foreach (@{$to})
		{
	  	  	send SOCK, "RCPT TO: $_\r\n", 0; recv SOCK, $err, 512, 0;
	    }
	}
	else
	{
	  	  	send SOCK, "RCPT TO: $to\r\n", 0; recv SOCK, $err, 512, 0;
	}
    send SOCK, "DATA\n", 0;
    recv SOCK, $err, 512, 0;
	send SOCK, ".\r\n", 0;
    recv SOCK, $err, 512, 0;
    send SOCK, "QUIT\r\n", 0;
    recv SOCK, $err, 512, 0;
    close SOCK;




}

sub set_header
{
	my $self;
	my $key;
	my $value;

	$self	=	shift;
	$key	=	shift;
	$value	=	shift;

	$self->{header}->{$key}		=	$value;
}

sub get_header
{
	my $self;
	my $key;

	$self	=	shift;
	$key	=	shift;

	if( defined $self->{header}->{$key} )
	{
		return( $self->{header}->{$key} );
	}
	else
	{
		return undef;
	}

}

sub get_body
{
	my	$self;
	$self	=	shift;
	return( $self->{body} );
}


sub to_str
{
	my	$self;
	my	$str;

	$self	=	shift;
	$str	=	"";

	foreach ( keys %{$self->{header}} )
	{
		$str	.=	$_ .": ". $self->{header}->{$_} . "\n";
	}
	$str	.=	"\n";
	$str	.=	$self->{body};
	return( $str );
}

1;

