#!/usr/bin/perl
# Copyright (c) vhffs project and its contributors
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# 1. Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
#2. Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
#3. Neither the name of vhffs nor the names of its contributors 
#   may be used to endorse or promote products derived from this 
#   software without specific prior written permission.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
#"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
#LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
#FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
#COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
#INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
#BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
#LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
#CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.


# Vhffs::Confirmation Perl Module
# 
# This module is used to check validity of data transmitting
# It creates an confirmation code an an ID
# The User must enter the confirmation code.


use strict;
use diagnostics;

package Vhffs::Panel::Confirmation;


#Create a confirmation code. Send an arrayref which contains cid and code
sub create_code
{
	my $vhffs;
	my $code;
	my $request;
	my $result;
	my $query;
	my @ret;
	my $cid;
	$vhffs = shift;
	$code = "";

	for (0 .. 7) { $code .= ('a'..'z', 'A'..'Z', '0'..'9')[int rand 62] ; }	

	$query 		= "INSERT INTO vhffs_confirmation (code) VALUES('".$code."')";
	$request 	= $vhffs->{'db'}->{'DB_WRITE'}->prepare( $query );
	$request->execute or return undef;

	$query 		= "SELECT max(cid) from vhffs_confirmation";
	$request 	= $vhffs->{'db'}->{'DB_READ'}->prepare( $query );
	#Returns 0 if nothing is found (stupid)
	return undef if( $request->execute == 0 );
	$result		= $request->fetchrow_arrayref;
	$cid		= $result->[0];
	$ret[0]		= $cid;
	$ret[1]		= $code;
	return( \@ret );
}

#Get a confirmation code according to the cid
sub get_code
{
	my 	$vhffs;
	my 	$cid;
	my	$query;
	my	$request;
	my	$result;

	$vhffs		=	shift;
	$cid		=	shift;
	$query 		= 	"SELECT code from vhffs_confirmation WHERE cid='".$cid."'";
	$request 	= 	$vhffs->{'db'}->{'DB_READ'}->prepare( $query );
	return undef if( $request->execute == 0 );

	$result 	= $request->fetchrow_arrayref;
	return $result->[0];
}

1;

